"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const get_1 = __importDefault(require("lodash/get"));
exports.default = async (db, params, options) => {
    // Fetch entry
    let fetched = await db.query(`SELECT * FROM ${options.table} WHERE ID = ($1)`, [params.id]);
    if (!fetched.rows.length)
        return null; // If empty, return null
    fetched = JSON.parse(fetched.rows[0].json);
    // Check if target was supplied
    if (params.ops.target)
        fetched = (0, get_1.default)(fetched, params.ops.target); // Get prop using dot notation
    return fetched;
};
//# sourceMappingURL=fetch.js.map