"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const set_1 = __importDefault(require("lodash/set"));
exports.default = async (db, params, options) => {
    // Fetch entry
    let fetched = await db.query(`SELECT * FROM ${options.table} WHERE ID = ($1)`, [params.id]);
    // If not found, create empty row
    if (!fetched.rows.length) {
        await db.query(`INSERT INTO ${options.table} (ID,json) VALUES ($1,$2)`, [
            params.id,
            "{}",
        ]);
        fetched = await db.query(`SELECT * FROM ${options.table} WHERE ID = ($1)`, [
            params.id,
        ]);
    }
    // Parse fetched
    fetched = JSON.parse(fetched.rows[0].json);
    // Check if a target was supplied
    if (typeof fetched === "object" && params.ops.target) {
        params.data = JSON.parse(params.data);
        params.data = (0, set_1.default)(fetched, params.ops.target, params.data);
    }
    else if (params.ops.target)
        throw new TypeError("Cannot target a non-object.");
    // Stringify data
    if (typeof params.data != "string")
        params.data = JSON.stringify(params.data);
    // Update entry with new data
    await db.query(`UPDATE ${options.table} SET json = ($1) WHERE ID = ($2)`, [
        params.data,
        params.id,
    ]);
    // Fetch and return new data
    const newData = await db.query(`SELECT * FROM ${options.table} WHERE ID = ($1)`, [params.id]);
    if (newData.rows[0].json)
        return null;
    else
        return JSON.parse(newData.rows[0].json);
};
//# sourceMappingURL=set.js.map